Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Communication/3.3/WcfService.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Communication/3.3/WcfService.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Communication/3.3/WcfService.cs	(revision 4423)
@@ -32,4 +32,5 @@
 using HeuristicLab.PluginInfrastructure;
 using HeuristicLab.Tracing;
+using HeuristicLab.Common;
 
 namespace HeuristicLab.Hive.Slave.Communication {
@@ -56,5 +57,4 @@
     public DateTime ConnectedSince { get; private set; }
     public NetworkEnum.WcfConnState ConnState { get; private set; }
-    public bool LoggedIn { get; set; }
 
     private string serverIp;
@@ -64,13 +64,13 @@
         if (serverIp != value) {
           serverIp = value;
-          if (ServerChanged != null)
-            ServerChanged(this, new EventArgs());
-        }
-      }
-    }
-
-    public event EventHandler ConnectionRestored;
-    public event EventHandler ServerChanged;
+        }
+      }
+    }
+
     public event EventHandler Connected;
+    public void OnConnected() {
+      var handler = Connected;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
 
     /// <summary>
@@ -79,5 +79,4 @@
     private WcfService() {
       ConnState = NetworkEnum.WcfConnState.Disconnected;
-      LoggedIn = false;
     }
 
@@ -85,8 +84,7 @@
     /// Connects with the Server, registers the events and fires the Connected (and quiet possibly the ConnectionRestored) Event.
     /// </summary>
-    public void Connect() {
+    public void Connect(SlaveDto slaveInfo) {
       ServiceLocator.Instance.HostAddress = ServerIp;
-      ServiceLocator.Instance.SlaveFacadePool.ExceptionOccured += new EventHandler<HeuristicLab.Common.EventArgs<Exception>>(ClientFacadePool_ExceptionOccured);
-      ServiceLocator.Instance.StreamedSlaveFacadePool.ExceptionOccured += new EventHandler<HeuristicLab.Common.EventArgs<Exception>>(ClientFacadePool_ExceptionOccured);
+      RegisterServiceEvents();
       using (Disposable<SlaveFacade.ISlaveFacade> service = ServiceLocator.Instance.StreamedSlaveFacadePool.GetService()) {
         try {
@@ -98,11 +96,6 @@
           ConnState = NetworkEnum.WcfConnState.Connected;
           ConnectedSince = DateTime.Now;
-
-          if (Connected != null) {
-            Connected(this, new EventArgs());
-          }
-          if (ConnState == NetworkEnum.WcfConnState.Failed) {
-            ConnectionRestored(this, new EventArgs());
-          }
+          service.Obj.Login(slaveInfo);
+          OnConnected();
         }
         catch (Exception ex) {
@@ -112,5 +105,16 @@
     }
 
-    void ClientFacadePool_ExceptionOccured(object sender, HeuristicLab.Common.EventArgs<Exception> e) {
+    private void RegisterServiceEvents() {
+      ServiceLocator.Instance.SlaveFacadePool.ExceptionOccured += new EventHandler<HeuristicLab.Common.EventArgs<Exception>>(ClientFacadePool_ExceptionOccured);
+      ServiceLocator.Instance.StreamedSlaveFacadePool.ExceptionOccured += new EventHandler<HeuristicLab.Common.EventArgs<Exception>>(ClientFacadePool_ExceptionOccured);
+    }
+
+    private void DeregisterServiceEvents() {
+      ServiceLocator.Instance.SlaveFacadePool.ExceptionOccured -= new EventHandler<HeuristicLab.Common.EventArgs<Exception>>(ClientFacadePool_ExceptionOccured);
+      ServiceLocator.Instance.StreamedSlaveFacadePool.ExceptionOccured -= new EventHandler<HeuristicLab.Common.EventArgs<Exception>>(ClientFacadePool_ExceptionOccured);
+    }
+
+    void ClientFacadePool_ExceptionOccured(object sender, EventArgs<Exception> e) {
+      HandleNetworkError(e.Value);
       Logger.Error("An exception occured in the WCF-Communication: " + e.Value.ToString());
     }
@@ -121,5 +125,5 @@
     public void Disconnect() {
       ConnState = NetworkEnum.WcfConnState.Disconnected;
-      LoggedIn = false;
+      DeregisterServiceEvents();
     }
 
@@ -130,5 +134,5 @@
     private void HandleNetworkError(Exception e) {
       ConnState = NetworkEnum.WcfConnState.Failed;
-      LoggedIn = false;
+      DeregisterServiceEvents();
       Logger.Error("Network exception occurred: " + e);
     }
@@ -137,24 +141,23 @@
     /// Methods for the Server Login
     /// </summary>
-    public void Login(SlaveDto slaveInfo) {
-      using (Disposable<SlaveFacade.ISlaveFacade> service = ServiceLocator.Instance.SlaveFacadePool.GetService()) {
-        try {
-          if (ConnState == NetworkEnum.WcfConnState.Connected) {
-            Logger.Debug("STARTED: Login Sync");
-            Response res = service.Obj.Login(slaveInfo);
-            if (res.StatusMessage != ResponseStatus.Ok) {
-              Logger.Error("FAILED: Login Failed! " + res.StatusMessage);
-              throw new Exception(res.StatusMessage.ToString());
-            } else {
-              Logger.Info("ENDED: Login succeeded" + res.StatusMessage);
-              LoggedIn = true;
-            }
-          }
-        }
-        catch (Exception e) {
-          HandleNetworkError(e);
-        }
-      }
-    }
+    //public void Login(SlaveDto slaveInfo) {
+    //  try {
+    //    using (Disposable<SlaveFacade.ISlaveFacade> service = ServiceLocator.Instance.SlaveFacadePool.GetService()) {
+    //      if (ConnState == NetworkEnum.WcfConnState.Connected) {
+    //        Logger.Debug("STARTED: Login Sync");
+    //        Response res = service.Obj.Login(slaveInfo);
+    //        if (res.StatusMessage != ResponseStatus.Ok) {
+    //          Logger.Error("FAILED: Login Failed! " + res.StatusMessage);
+    //          throw new Exception(res.StatusMessage.ToString());
+    //        } else {
+    //          Logger.Info("ENDED: Login succeeded" + res.StatusMessage);
+    //        }
+    //      }
+    //    }
+    //  }
+    //  catch (Exception e) {
+    //    OnExceptionOccured(e);
+    //  }
+    //}
 
     /// <summary>
@@ -164,49 +167,50 @@
     public event System.EventHandler<GetJobCompletedEventArgs> GetJobCompleted;
     public void GetJobAsync(Guid guid) {
-      if (LoggedIn) {
-        Disposable<SlaveFacade.ISlaveFacade> service = ServiceLocator.Instance.StreamedSlaveFacadePool.GetService();
-        Logger.Debug("STARTED: Fetching of Jobs from Server for Slave");
-        service.Obj.BeginGetStreamedJob(guid, (ar => {
+      Disposable<SlaveFacade.ISlaveFacade> service = ServiceLocator.Instance.StreamedSlaveFacadePool.GetService();
+      Logger.Debug("STARTED: Fetching of Jobs from Server for Slave");
+      service.Obj.BeginGetStreamedJob(guid, (ar => {
+        Stream stream = null;
+        MemoryStream memStream = null;
+        try {
           if (ar.IsCompleted) {
-            Stream stream = null;
-            MemoryStream memStream = null;
-            try {
-              Logger.Debug("ENDED: Fetching of Jobs from Server for Slave");
-              stream = service.Obj.EndGetStreamedJob(ar);
-
-              //first deserialize the response
-              BinaryFormatter formatter = new BinaryFormatter();
-              ResponseObject<JobDto> response = (ResponseObject<JobDto>)formatter.Deserialize(stream);
-
-              //second deserialize the BLOB
-              memStream = new MemoryStream();
-
-              byte[] buffer = new byte[3024];
-              int read = 0;
-              while ((read = stream.Read(buffer, 0, buffer.Length)) > 0) {
-                memStream.Write(buffer, 0, read);
-              }
-
-              memStream.Close();
-
-              GetJobCompletedEventArgs completedEventArgs = new GetJobCompletedEventArgs(new object[] { response, memStream.GetBuffer() }, null, !ar.IsCompleted, ar.AsyncState);
-              GetJobCompleted(this, completedEventArgs);
+            Logger.Debug("ENDED: Fetching of Jobs from Server for Slave");
+            stream = service.Obj.EndGetStreamedJob(ar);
+
+            //first deserialize the response
+            BinaryFormatter formatter = new BinaryFormatter();
+            ResponseObject<JobDto> response = (ResponseObject<JobDto>)formatter.Deserialize(stream);
+
+            //second deserialize the BLOB
+            memStream = new MemoryStream();
+
+            byte[] buffer = new byte[3024];
+            int read = 0;
+            while ((read = stream.Read(buffer, 0, buffer.Length)) > 0) {
+              memStream.Write(buffer, 0, read);
             }
-            catch (Exception ex) {
-              Logger.Error(ex);
-            }
-            finally {
-              if (stream != null)
-                stream.Dispose();
-
-              if (memStream != null)
-                memStream.Dispose();
-
-              service.Dispose();
-            }
-          } else
+
+            memStream.Close();
+
+            GetJobCompletedEventArgs completedEventArgs = new GetJobCompletedEventArgs(new object[] { response, memStream.GetBuffer() }, null, !ar.IsCompleted, ar.AsyncState);
+            GetJobCompleted(this, completedEventArgs);
+
+          } else {
             HandleNetworkError(new FaultException("GetJobAsync did not complete"));
-        }), null);
-      }
+          }
+        }
+        catch (Exception e) {
+          OnExceptionOccured(e);
+        }
+        finally {
+          if (stream != null)
+            stream.Dispose();
+
+          if (memStream != null)
+            memStream.Dispose();
+
+          try { service.Dispose(); }
+          catch (Exception e) { OnExceptionOccured(e); }
+        }
+      }), null);
     }
 
@@ -218,34 +222,36 @@
     #region SendJobResults
     public event System.EventHandler<StoreFinishedJobResultCompletedEventArgs> GetFinishedJobResultCompleted;
-    public void GetFinishedJobResultAsync(Guid clientId, Guid jobId, byte[] result, double percentage, Exception exception, bool finished) {
-      if (LoggedIn) {
-        Disposable<SlaveFacade.ISlaveFacade> service = ServiceLocator.Instance.StreamedSlaveFacadePool.GetService();
-        Logger.Debug("STARTED: Sending back the finished job results");
-        Logger.Debug("Building stream");
-        Stream stream = GetStreamedJobResult(clientId, jobId, result, percentage, exception);
-        Logger.Debug("Builded stream");
-        Logger.Debug("Making the call");
-        
-        service.Obj.BeginStoreFinishedJobResultStreamed(stream, (ar => {
-          try {
-            Logger.Debug("Finished storing the job");
-            if (stream != null)
-              stream.Dispose();
-
-            if (ar.IsCompleted) {
-              var res = service.Obj.EndStoreFinishedJobResultStreamed(ar);
-              StoreFinishedJobResultCompletedEventArgs args = new StoreFinishedJobResultCompletedEventArgs(new object[] { res }, null, false, null);
-              Logger.Debug("calling the Finished Job Event");
-              GetFinishedJobResultCompleted(this, args);
-              Logger.Debug("ENDED: Sending back the finished job results");
-            } else {
-              HandleNetworkError(new FaultException("GetFinishedJobResultAsync did not complete"));
-            }
+    public void GetFinishedJobResultAsync(Guid clientId, Guid jobId, byte[] result, TimeSpan executionTime, string exception, bool finished) {
+      Disposable<SlaveFacade.ISlaveFacade> service = ServiceLocator.Instance.StreamedSlaveFacadePool.GetService();
+      Logger.Debug("STARTED: Sending back the finished job results");
+      Logger.Debug("Building stream");
+      Stream stream = GetStreamedJobResult(clientId, jobId, result, executionTime, exception);
+      Logger.Debug("Builded stream");
+      Logger.Debug("Making the call");
+
+      service.Obj.BeginStoreFinishedJobResultStreamed(stream, (ar => {
+        try {
+          Logger.Debug("Finished storing the job");
+          if (stream != null)
+            stream.Dispose();
+
+          if (ar.IsCompleted) {
+            var res = service.Obj.EndStoreFinishedJobResultStreamed(ar);
+            StoreFinishedJobResultCompletedEventArgs args = new StoreFinishedJobResultCompletedEventArgs(new object[] { res }, null, false, null);
+            Logger.Debug("calling the Finished Job Event");
+            GetFinishedJobResultCompleted(this, args);
+            Logger.Debug("ENDED: Sending back the finished job results");
+          } else {
+            HandleNetworkError(new FaultException("GetFinishedJobResultAsync did not complete"));
           }
-          finally {
-            service.Dispose();
-          }
-        }), null);
-      }
+        }
+        catch (Exception e) {
+          OnExceptionOccured(e);
+        }
+        finally {
+          try { service.Dispose(); }
+          catch (Exception e) { OnExceptionOccured(e); }
+        }
+      }), null);
     }
 
@@ -254,27 +260,29 @@
     #region Processsnapshots
     public event System.EventHandler<ProcessSnapshotCompletedEventArgs> ProcessSnapshotCompleted;
-    public void ProcessSnapshotAsync(Guid clientId, Guid jobId, byte[] result, double percentage, Exception exception, bool finished) {
-      if (LoggedIn) {
-        Disposable<SlaveFacade.ISlaveFacade> service = ServiceLocator.Instance.StreamedSlaveFacadePool.GetService();
-
-        Stream stream = GetStreamedJobResult(clientId, jobId, result, percentage, exception);
-        service.Obj.BeginProcessSnapshotStreamed(stream, (ar => {
-          try {
-            if (stream != null)
-              stream.Dispose();
-
-            if (ar.IsCompleted) {
-              var res = service.Obj.EndStoreFinishedJobResultStreamed(ar);
-              ProcessSnapshotCompletedEventArgs args = new ProcessSnapshotCompletedEventArgs(new object[] { res }, null, false, null);
-              ProcessSnapshotCompleted(this, args);
-            } else {
-              HandleNetworkError(new FaultException("ProcessSnapshotAsync did not complete"));
-            }
+    public void ProcessSnapshotAsync(Guid clientId, Guid jobId, byte[] result, TimeSpan executionTime, string exception, bool finished) {
+      Disposable<SlaveFacade.ISlaveFacade> service = ServiceLocator.Instance.StreamedSlaveFacadePool.GetService();
+
+      Stream stream = GetStreamedJobResult(clientId, jobId, result, executionTime, exception);
+      service.Obj.BeginProcessSnapshotStreamed(stream, (ar => {
+        try {
+          if (stream != null)
+            stream.Dispose();
+
+          if (ar.IsCompleted) {
+            var res = service.Obj.EndStoreFinishedJobResultStreamed(ar);
+            ProcessSnapshotCompletedEventArgs args = new ProcessSnapshotCompletedEventArgs(new object[] { res }, null, false, null);
+            ProcessSnapshotCompleted(this, args);
+          } else {
+            HandleNetworkError(new FaultException("ProcessSnapshotAsync did not complete"));
           }
-          finally {
-            service.Dispose();
-          }
-        }), null);
-      }
+        }
+        catch (Exception e) {
+          OnExceptionOccured(e);
+        }
+        finally {
+          try { service.Dispose(); }
+          catch (Exception e) { OnExceptionOccured(e); }
+        }
+      }), null);
     }
 
@@ -286,19 +294,15 @@
     #region Heartbeat
 
-    public event System.EventHandler<ProcessHeartBeatCompletedEventArgs> ProcessHeartBeatCompleted;
+    public event EventHandler<ProcessHeartBeatCompletedEventArgs> ProcessHeartBeatCompleted;
     public void ProcessHeartBeatSync(HeartBeatData hbd) {
-      if (LoggedIn) {
-        using (Disposable<SlaveFacade.ISlaveFacade> service = ServiceLocator.Instance.StreamedSlaveFacadePool.GetService()) {
-          Logger.Debug("STARTING: sending heartbeat");
-          var res = service.Obj.ProcessHeartBeat(hbd);
-
-          if (res.StatusMessage == ResponseStatus.Ok) {
-            ProcessHeartBeatCompleted(this, new ProcessHeartBeatCompletedEventArgs(new object[] { res }, null, false, null));
-            Logger.Debug("ENDED: sending heartbeats");
-          } else if (res.StatusMessage == ResponseStatus.ProcessHeartBeat_UserNotLoggedIn) {
-            LoggedIn = false;
-          } else {
-            Logger.Error("FAILED: sending heartbeats: " + res.StatusMessage.ToString());
-          }
+      using (Disposable<SlaveFacade.ISlaveFacade> service = ServiceLocator.Instance.StreamedSlaveFacadePool.GetService()) {
+        Logger.Debug("STARTING: sending heartbeat");
+        var res = service.Obj.ProcessHeartBeat(hbd);
+
+        if (res.StatusMessage == ResponseStatus.Ok) {
+          ProcessHeartBeatCompleted(this, new ProcessHeartBeatCompletedEventArgs(new object[] { res }, null, false, null));
+          Logger.Debug("ENDED: sending heartbeats");
+        } else {
+          Logger.Error("FAILED: sending heartbeats: " + res.StatusMessage.ToString());
         }
       }
@@ -310,10 +314,10 @@
     /// Send back finished and Stored Job Results
     /// </summary>
-    private Stream GetStreamedJobResult(Guid clientId, Guid jobId, byte[] result, double percentage, Exception exception) {
+    private Stream GetStreamedJobResult(Guid clientId, Guid jobId, byte[] result, TimeSpan executionTime, string exception) {
       JobResult jobResult = new JobResult();
       jobResult.SlaveId = clientId;
       jobResult.Id = jobId;
-      jobResult.Percentage = percentage;
-      jobResult.Exception = exception != null ? exception.Message : "";
+      jobResult.ExecutionTime = executionTime;
+      jobResult.Exception = exception;
 
       MultiStream stream = new MultiStream();
@@ -329,7 +333,7 @@
     }
 
-    public ResponseResultReceived StoreFinishedJobResultsSync(Guid clientId, Guid jobId, byte[] result, double percentage, Exception exception, bool finished) {
+    public ResponseResultReceived StoreFinishedJobResultsSync(Guid clientId, Guid jobId, byte[] result, TimeSpan executionTime, string exception, bool finished) {
       using (Disposable<SlaveFacade.ISlaveFacade> service = ServiceLocator.Instance.StreamedSlaveFacadePool.GetService()) {
-        ResponseResultReceived res = service.Obj.StoreFinishedJobResultStreamed(GetStreamedJobResult(clientId, jobId, result, percentage, exception));
+        ResponseResultReceived res = service.Obj.StoreFinishedJobResultStreamed(GetStreamedJobResult(clientId, jobId, result, executionTime, exception));
         return res;
       }
@@ -346,17 +350,17 @@
       }
       catch (Exception e) {
-        HandleNetworkError(e);
-        return null;
-      }
-    }
-
-    public ResponseResultReceived ProcessSnapshotSync(Guid clientId, Guid jobId, byte[] result, double percentage, Exception exception) {
-      try {
-        using (Disposable<SlaveFacade.ISlaveFacade> service = ServiceLocator.Instance.StreamedSlaveFacadePool.GetService()) {
-          return service.Obj.ProcessSnapshotStreamed(GetStreamedJobResult(clientId, jobId, result, percentage, exception));
-        }
-      }
-      catch (Exception e) {
-        HandleNetworkError(e);
+        OnExceptionOccured(e);
+        return null;
+      }
+    }
+
+    public ResponseResultReceived ProcessSnapshotSync(Guid clientId, Guid jobId, byte[] result, TimeSpan executionTime, string exception) {
+      try {
+        using (Disposable<SlaveFacade.ISlaveFacade> service = ServiceLocator.Instance.StreamedSlaveFacadePool.GetService()) {
+          return service.Obj.ProcessSnapshotStreamed(GetStreamedJobResult(clientId, jobId, result, executionTime, exception));
+        }
+      }
+      catch (Exception e) {
+        OnExceptionOccured(e);
         return null;
       }
@@ -380,5 +384,5 @@
       }
       catch (Exception e) {
-        HandleNetworkError(e);
+        OnExceptionOccured(e);
         return null;
       }
@@ -394,5 +398,5 @@
       }
       catch (Exception e) {
-        HandleNetworkError(e);
+        OnExceptionOccured(e);
       }
     }
@@ -408,5 +412,5 @@
       }
       catch (Exception e) {
-        HandleNetworkError(e);
+        OnExceptionOccured(e);
         return null;
       }
@@ -423,5 +427,5 @@
       }
       catch (Exception e) {
-        HandleNetworkError(e);
+        OnExceptionOccured(e);
         return null;
       }
@@ -438,5 +442,5 @@
       }
       catch (Exception e) {
-        HandleNetworkError(e);
+        OnExceptionOccured(e);
         return null;
       }
@@ -453,5 +457,5 @@
       }
       catch (Exception e) {
-        HandleNetworkError(e);
+        OnExceptionOccured(e);
         return null;
       }
@@ -475,7 +479,25 @@
       }
       catch (Exception e) {
-        HandleNetworkError(e);
-        return null;
-      }
+        OnExceptionOccured(e);
+        return null;
+      }
+    }
+
+    public void DeleteChildJobs(Guid jobId) {
+      try {
+        using (Disposable<SlaveFacade.ISlaveFacade> service = ServiceLocator.Instance.StreamedSlaveFacadePool.GetService()) {
+          service.Obj.DeleteChildJobs(jobId);
+        }
+      }
+      catch (Exception e) {
+        OnExceptionOccured(e);
+      }
+    }
+
+    public event EventHandler<EventArgs<Exception>> ExceptionOccured;
+    private void OnExceptionOccured(Exception e) {
+      Logger.Error("Error: " + e.ToString());
+      var handler = ExceptionOccured;
+      if (handler != null) handler(this, new EventArgs<Exception>(e));
     }
   }
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Console/3.3/HiveSlaveConsole.designer.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Console/3.3/HiveSlaveConsole.designer.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Console/3.3/HiveSlaveConsole.designer.cs	(revision 4423)
@@ -46,7 +46,7 @@
     private void InitializeComponent() {
       this.components = new System.ComponentModel.Container();
-      Calendar.DrawTool drawTool2 = new Calendar.DrawTool();
+      HeuristicLab.Calendar.DrawTool drawTool1 = new HeuristicLab.Calendar.DrawTool();
       System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(HiveSlaveConsole));
-      this.dvOnline = new Calendar.DayView();
+      this.dvOnline = new HeuristicLab.Calendar.DayView();
       this.tcClientConsole = new System.Windows.Forms.TabControl();
       this.tpConnection = new System.Windows.Forms.TabPage();
@@ -57,10 +57,9 @@
       this.tbIPAdress = new System.Windows.Forms.TextBox();
       this.lbServerIPCaption = new System.Windows.Forms.Label();
-      this.lbPortCaption = new System.Windows.Forms.Label();
       this.gbJobCommon = new System.Windows.Forms.GroupBox();
       this.lvJobDetail = new System.Windows.Forms.ListView();
-      this.chJobId = new System.Windows.Forms.ColumnHeader();
-      this.chSince = new System.Windows.Forms.ColumnHeader();
-      this.chProgress = new System.Windows.Forms.ColumnHeader();
+      this.chJobId = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
+      this.chSince = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
+      this.chProgress = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
       this.gbCommon = new System.Windows.Forms.GroupBox();
       this.pbGraph = new System.Windows.Forms.PictureBox();
@@ -80,4 +79,5 @@
       this.txtLog = new System.Windows.Forms.TextBox();
       this.tabPage2 = new System.Windows.Forms.TabPage();
+      this.btnUpdateCalender = new System.Windows.Forms.Button();
       this.btnSaveCal = new System.Windows.Forms.Button();
       this.groupBox1 = new System.Windows.Forms.GroupBox();
@@ -95,5 +95,4 @@
       this.pictureBox1 = new System.Windows.Forms.PictureBox();
       this.ilEventLog = new System.Windows.Forms.ImageList(this.components);
-      this.btnUpdateCalender = new System.Windows.Forms.Button();
       this.tcClientConsole.SuspendLayout();
       this.tpConnection.SuspendLayout();
@@ -110,9 +109,9 @@
       // dvOnline
       // 
-      drawTool2.DayView = this.dvOnline;
-      this.dvOnline.ActiveTool = drawTool2;
+      drawTool1.DayView = this.dvOnline;
+      this.dvOnline.ActiveTool = drawTool1;
       this.dvOnline.AmPmDisplay = false;
-      this.dvOnline.AppointmentDuration = Calendar.AppointmentSlotDuration.SixtyMinutes;
-      this.dvOnline.AppointmentHeightMode = Calendar.AppHeightDrawMode.TrueHeightAll;
+      this.dvOnline.AppointmentDuration = HeuristicLab.Calendar.AppointmentSlotDuration.SixtyMinutes;
+      this.dvOnline.AppointmentHeightMode = HeuristicLab.Calendar.AppHeightDrawMode.TrueHeightAll;
       this.dvOnline.DayHeadersHeight = 15;
       this.dvOnline.DaysToShow = 7;
@@ -168,5 +167,4 @@
       this.gbServerConnection.Controls.Add(this.tbIPAdress);
       this.gbServerConnection.Controls.Add(this.lbServerIPCaption);
-      this.gbServerConnection.Controls.Add(this.lbPortCaption);
       this.gbServerConnection.Location = new System.Drawing.Point(346, 6);
       this.gbServerConnection.Name = "gbServerConnection";
@@ -222,13 +220,4 @@
       this.lbServerIPCaption.TabIndex = 0;
       this.lbServerIPCaption.Text = "IP address:";
-      // 
-      // lbPortCaption
-      // 
-      this.lbPortCaption.AutoSize = true;
-      this.lbPortCaption.Location = new System.Drawing.Point(48, 62);
-      this.lbPortCaption.Name = "lbPortCaption";
-      this.lbPortCaption.Size = new System.Drawing.Size(29, 13);
-      this.lbPortCaption.TabIndex = 1;
-      this.lbPortCaption.Text = "Port:";
       // 
       // gbJobCommon
@@ -446,4 +435,14 @@
       this.tabPage2.UseVisualStyleBackColor = true;
       // 
+      // btnUpdateCalender
+      // 
+      this.btnUpdateCalender.Location = new System.Drawing.Point(633, 136);
+      this.btnUpdateCalender.Name = "btnUpdateCalender";
+      this.btnUpdateCalender.Size = new System.Drawing.Size(199, 26);
+      this.btnUpdateCalender.TabIndex = 42;
+      this.btnUpdateCalender.Text = "Update Calender";
+      this.btnUpdateCalender.UseVisualStyleBackColor = true;
+      this.btnUpdateCalender.Click += new System.EventHandler(this.btnUpdateCalender_Click);
+      // 
       // btnSaveCal
       // 
@@ -594,15 +593,5 @@
       this.ilEventLog.Images.SetKeyName(1, "Error.png");
       // 
-      // btnUpdateCalender
-      // 
-      this.btnUpdateCalender.Location = new System.Drawing.Point(633, 136);
-      this.btnUpdateCalender.Name = "btnUpdateCalender";
-      this.btnUpdateCalender.Size = new System.Drawing.Size(199, 26);
-      this.btnUpdateCalender.TabIndex = 42;
-      this.btnUpdateCalender.Text = "Update Calender";
-      this.btnUpdateCalender.UseVisualStyleBackColor = true;
-      this.btnUpdateCalender.Click += new System.EventHandler(this.btnUpdateCalender_Click);
-      // 
-      // HiveClientConsole
+      // HiveSlaveConsole
       // 
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
@@ -614,5 +603,5 @@
       this.MaximizeBox = false;
       this.MinimizeBox = false;
-      this.Name = "HiveClientConsole";
+      this.Name = "HiveSlaveConsole";
       this.Text = "Client Console (loading...)";
       this.tcClientConsole.ResumeLayout(false);
@@ -666,5 +655,4 @@
     private System.Windows.Forms.TextBox tbIPAdress;
     private System.Windows.Forms.Label lbServerIPCaption;
-    private System.Windows.Forms.Label lbPortCaption;
     private System.Windows.Forms.GroupBox groupBox1;
     private System.Windows.Forms.Button btCreate;
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/ConfigurationManager/ConfigManager.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/ConfigurationManager/ConfigManager.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/ConfigurationManager/ConfigManager.cs	(revision 4423)
@@ -107,6 +107,6 @@
       st.ConnectedSince = WcfService.Instance.ConnectedSince;
 
-      st.TotalCores = hardwareInfo.NrOfCores;
-      st.FreeCores = hardwareInfo.NrOfCores - GetUsedCores();
+      st.TotalCores = hardwareInfo.NrOfCores.HasValue ? hardwareInfo.NrOfCores.Value : 0;
+      st.FreeCores = hardwareInfo.NrOfCores.HasValue ? hardwareInfo.NrOfCores.Value - GetUsedCores() : 0;
 
       st.JobsAborted = SlaveStatusInfo.JobsAborted;
@@ -120,5 +120,5 @@
         foreach (KeyValuePair<Guid, Executor> kvp in engines) {
           Executor e = kvp.Value;
-          st.Jobs.Add(new JobStatus { JobId = e.JobId, Progress = e.Progress, Since = e.CreationTime });
+          st.Jobs.Add(new JobStatus { JobId = e.JobId, ExecutionTime = e.ExecutionTime, Since = e.CreationTime });
         }
       }
@@ -126,12 +126,11 @@
     }
 
-    public Dictionary<Guid, double> GetProgressOfAllJobs() {
-      Dictionary<Guid, double> prog = new Dictionary<Guid, double>();
+    public Dictionary<Guid, TimeSpan> GetExecutionTimeOfAllJobs() {
+      Dictionary<Guid, TimeSpan> prog = new Dictionary<Guid, TimeSpan>();
       Dictionary<Guid, Executor> engines = Core.ExecutionEngines;
       lock (engines) {
         foreach (KeyValuePair<Guid, Executor> kvp in engines) {
           Executor e = kvp.Value;
-          //if (!e.JobIsFinished) 
-          prog[e.JobId] = e.Progress;
+          prog[e.JobId] = e.ExecutionTime;
         }
       }
